#import <Foundation/Foundation.h>
#import "Socket.h"

#define arraySize (8*1024)

Socket *mySocket;
short end[arraySize];

/***
This program reads buffers of audio data
from a socket and dsiplays them on the screen.
***/

int main (int argc, const char * argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    NSMutableData *caught;
    int i, port, returned; port = 3030;
    NSString *host = [[NSString alloc] initWithCString:"localhost"];

    // initialize buffer
    for ( i = 0; i < arraySize; i++)
        end[i] = 0;
    
    // show buffer contents
    //for ( i = 0; i < arraySize; i++)
    //NSLog(@"end[%i]:%i", i, end[i]);

    // initialize socket
    mySocket = [[Socket alloc] init];
    [mySocket setReadBufferSize:(arraySize * sizeof(short))];

    // initialize socket buffer
    caught = [[NSMutableData alloc] initWithCapacity:(arraySize * sizeof(short))];

    // connect to host
    [mySocket connectToHostName:host port:port];
    [host release];

    // receive data from socket
    returned = [mySocket readData:caught];
    
    // put data in buffer
    [caught getBytes:end];
    [caught release];
    
    NSLog(@"******************");
    NSLog(@"number of byets received:%i", returned);

    // show contents of buffer
    for ( i = 0; i < arraySize; i++)
        NSLog(@"end[%i]:%i", i, end[i]);

    NSLog(@"Goodbye.");
    
    [pool release];
    return 0;
}
