#import <Foundation/Foundation.h>
#import <stdio.h>
#import <unistd.h>
#import "Socket.h"
#import "Server.h"

#define arraySize (8*1024)

Socket *mySocket;

/***
This program opens a file, reads from it, and sends the
audio data down a socket to a client.
***/

int main (int argc, const char * argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    // declarations
    short start[arraySize];
    NSData *transit;
    int port; port = 3030;
    unsigned int bytesRead;
    NSString *path;
    const char *pathStr;
    const char *filePath = "/Volumes/My Precious/Users/gappin/Desktop/The Folder/Monica.aifc";
    FILE *file;

    // get the file
    path = [[NSString alloc] initWithCString:filePath];
    pathStr = [path fileSystemRepresentation];
    file = fopen(pathStr, "r");
    if (!file) {
        perror(pathStr);
        return 21;
    }

    //check the file and search to audio data
    findAudioData(file);

    // initialize socket
    mySocket = [[Socket alloc] init];
    [mySocket listenOnPort:port];
    NSLog(@"Socket created. Listening on port:%i\n", port);
    [mySocket acceptConnection];
    NSLog(@"Connection established.\n");

    int showMe, i; showMe = 1;
    
    while (!feof(file)) {
        // read from the file
        bytesRead = AIFFRead(file, start, arraySize);
        NSLog(@"Bytes read from file:%i\n", bytesRead);

        /***
        // show contents of buffer of data once
        if (showMe == 1) {
            showMe = 0;
            for ( i = 0; i < arraySize; i++)
                NSLog(@"end[%i]:%i", i, start[i]);
        }
        ***/
        
        // transmit the data
        NSLog(@"Sending data.");
        transit = [[NSData alloc] initWithBytes:start length:(arraySize * sizeof(short))];
        [mySocket writeData:transit];
        [transit release];
        
//        getchar();
        usleep( 5 * 1000 * 1000);
    }

    NSLog(@"Goodbye.\n");

    [pool release];
    return 0;
}
