#import "Controller.h"


@implementation Controller

- (IBAction)changeFreq:(id)sender
{
//    NSLog(@"in Controller:changeFreq");
    float freq = [freqSlider floatValue];
    [freqTextField setFloatValue:freq];
    [sineMaker setFreq:freq];
}

- (IBAction)changeAmp:(id)sender
{
    float amp = [ampSlider floatValue];
    [ampTextField setFloatValue:amp];
    [sineMaker setAmp:amp];
}

- (IBAction)startSine:(id)sender
{
//    NSLog(@"in Controller:startSine");
    [sineMaker playSine];
}

- (IBAction)stopSine:(id)sender
{
//    NSLog(@"in Controller:stopSine");
    [sineMaker stopSine];
}

- (void)awakeFromNib
{
    [sineMaker setup];
    [sineMaker printConfig];
    [self changeFreq:self];
    [self changeAmp:self];
    [ourWindow  makeKeyAndOrderFront: self];
}

@end
