#import <Cocoa/Cocoa.h>
#import <CoreAudio/CoreAudio.h>


@interface SineGenerator : NSObject
{
    AudioDeviceID		outputDevice;
    AudioStreamBasicDescription	outputDescription;
    UInt32			outputBufferSize;
    float			freq;
    float			amp;
    BOOL			initialized;
    BOOL			soundPlaying;
}

- (void) setup;
- (void) printConfig;
- (void) playSine;
- (void) stopSine;
- (void) setFreq:(float)newFreq;
- (void) setAmp:(float)newAmp;

@end