#import <Foundation/Foundation.h>
#import "PGStuff.h"
#import "AIFFPlay.h"
#import "AIFFStuff.h"
#import "Playthrough.h"

#define	kMaxStringSize	1024

int main (int argc, const char * argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    
    /***/
    char userWant;
    char fileName[kMaxStringSize];
    int err;
    
topMenu:
    printf("Welcome to my real time audio application.\n\n");
    printf("1 - Play a sound file\n");
    printf("2 - Record a sound file\n");
    printf("3 - Play mic through speakers\n");
    printf("4 - Serve a sound file\n");
    printf("5 - Receive a sound file\n");
    printf("\n6 - Quit\n");
    printf("\n(You may also use ^C to quit at any time.)");
    printf("\n\n\n\n\n\n\n\n");
    printf("\nEnter your choice:");
    scanf("%c", &userWant);
    
    // if invalid input
    if (userWant < '1' || userWant > '5')
    {
        // clear the buffer
        clearUserInput();
        // and return to the menu
        goto topMenu;
    }
    else
        clearUserInput();

    switch (userWant) {
        case '1':
            choice1:
            printf("Enter the file name:");
            getline(fileName, kMaxStringSize);
            printf("file name:%s\n", fileName);
            // check to see if the file exists
            if(!theFileExist(fileName)) {
                goto choice1;
            }
            // play it!
            if ( err = playAiffFile(fileName) > 0) {
                goto topMenu;
            }
            else {
                break;
            }

                /***
            case '2':
            break;
            ***/
        case '3':
            mainSoftPlayThru();
            break;
            /***
        case '4':
            break;
        case '5':
            break;
        case '6':
            return 0;
            ***/
        default:
            goto topMenu;
            break;            
    }
   /***/

    [pool release];
    
    return 0;
}