#import <Foundation/Foundation.h>
#import <stdio.h>
#import "Socket.h"

#define arraySize 10

Socket *mySocket;

/***
This program displays and sends 10 shorts
(20 bytes) down a socket to a client.
***/

int main (int argc, const char * argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    short int start[arraySize];
    NSData *transit;
    int i, port; port = 3030;

    // initialize buffer
    for ( i = 0; i < arraySize; i++)
        start[i] = i;

    // display buffer
    for ( i = 0; i < arraySize; i++)
        NSLog(@"start[%i]:%i", i, start[i]);

    // initialize socket
    mySocket = [[Socket alloc] init];
    [mySocket listenOnPort:port];
    NSLog(@"Socket created. Listening on port:%i", port);
    [mySocket acceptConnection];
    NSLog(@"Connection established.");

    // transmit the data
    NSLog(@"Sending data.");
    transit = [[NSData alloc] initWithBytes:start length:(arraySize * sizeof(short))];
    [mySocket writeData:transit];
    [transit release];

    NSLog(@"Goodbye.");

    [pool release];
    return 0;
}
