#import <Cocoa/Cocoa.h>
#import <CoreAudio/AudioHardware.h>

@interface Controller : NSObject
{
    IBOutlet id _mainWindow;
    UInt32 _bufferSize;
    AudioDeviceID _device;
    AudioStreamBasicDescription	_format;
    
    BOOL _deviceReady;
    BOOL _isPlaying;
}
-(IBAction) playSine:(id)sender;
-(IBAction) stopPlaying:(id)sender;
-(void) setupSoundDevice;

-(UInt32) bufferSize;
-(double) sampleRate;
@end
